<?php

namespace Drupal\me_config_pages\EventSubscriber;

use Drupal\Core\Config\ConfigFactoryInterface;
use Drupal\Core\Routing\RouteSubscriberBase;
use Drupal\Core\Routing\RoutingEvents;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Symfony\Component\Routing\RouteCollection;

/**
 * Route subscriber class for ME Config Pages.
 */
class MercuryEditorConfigPagesFormSubscriber extends RouteSubscriberBase implements EventSubscriberInterface {

  /**
   * Service constructor.
   *
   * @param \Drupal\Core\Config\ConfigFactoryInterface $configFactory
   *   The config factory service.
   */
  public function __construct(protected ConfigFactoryInterface $configFactory) {}

  /**
   * {@inheritDoc}
   */
  protected function alterRoutes(RouteCollection $collection) {
    $config = $this->configFactory->get('me_config_pages.settings');
    $me_config_pages = $config->get('config_pages_types') ?? [];

    foreach ($me_config_pages as $machine_name) {
      if ($route = $collection->get("config_pages.{$machine_name}")) {
        $route->setDefault(
          '_controller',
          '\Drupal\me_config_pages\Controller\MercuryEditorConfigPagesController::classInit'
        );
      }
    }
  }

  /**
   * {@inheritDoc}
   */
  public static function getSubscribedEvents() : array {
    $events[RoutingEvents::ALTER] = ['onAlterRoutes', -100];
    return $events;
  }

}
